﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class InputManager : MonoBehaviour
{
    SelectionBoxHandler _selector;

    public List<RoomScript> _rooms;
    public List<WitnessScript> _witnesses;


    // Start is called before the first frame update
    void Start()
    {
        _selector = FindObjectOfType<SelectionBoxHandler>();

        Object[] rooms = FindObjectsOfType<RoomScript>();

        for(int i = 0; i < rooms.Length; i++)
        {
            RoomScript r = rooms[i] as RoomScript;
            _rooms.Add(r);
        }


        Object[] witnesses = FindObjectsOfType<WitnessScript>();

        for (int i = 0; i < witnesses.Length; i++)
        {
            WitnessScript w = witnesses[i] as WitnessScript;
            _witnesses.Add(w);
        }
    }

    // Update is called once per frame
    void Update()
    {
        if(Input.GetMouseButtonDown(0))
            _selector.SelectBegin();

        if (Input.GetMouseButtonUp(0))
            _selector.SelectEnd();

        if(Input.GetMouseButtonDown(1))
        {
            TestDetectiveCommand();
        }
    }

    void TestDetectiveCommand()
    {
        if (_selector.selectedDetectives.Count == 1)
        {
            Vector3 mousePos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
            mousePos.y = 0;

            for(int i = 0; i < _witnesses.Count; i++)
            {
                DetectiveScript d = _selector.selectedDetectives[0].GetComponent<DetectiveScript>();

                if (_witnesses[i].witnessCollider.bounds.Contains(mousePos) && d.State == 0)
                {
                    //Interrogate this witness;
                    d.Interrogate(_witnesses[i]);
                    return;
                }
            }

            for (int i = 0; i < _rooms.Count; i++)
            {
                DetectiveScript d = _selector.selectedDetectives[0].GetComponent<DetectiveScript>();

                for (int j = 0; j < _rooms[i].roomCollider.Length; j++)
                {
                    if (_rooms[i].roomCollider[j].bounds.Contains(mousePos) && d.State == 0 && !_rooms[i].searched)
                    {
                        //Search this room.
                        d.SearchRoom(_rooms[i]);
                        return;
                    }
                }
            }
        }
    }
}