﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PenelopeScript : DetectiveScript
{

    // Start is called before the first frame update
    override protected void Start()
    {
        base.Start();
    }

    // Update is called once per frame
    void Update()
    {
        
    }

    float Ability1(float searchTime)
    {
        return searchTime / 3.0f;
    }

    float Ability2(float interrogationTime)
    {
        return interrogationTime / 2.0f;
    }

    /// <summary>
    /// Searches any room given with the detective who calls the function.
    /// </summary>
    /// <param name="r">A Reference to the room that we are attempting to search</param>
    override public void SearchRoom(RoomScript r)
    {
        //Sets up some local variables to calculate the time that the search is going to take.
        float timeToSearch, roomSize;

        //Calculates the size of the room given by public variables.
        roomSize = r.thisRoom.Dimensions.x * r.thisRoom.Dimensions.y;

        //Does the math to calculate search time.
        timeToSearch = ((110 - DetectiveStats.SearchAbility) / 10.0f) * roomSize;

        MoveToRoom(r);

        if (ab1Active)
        {
            timeToSearch = timeToSearch / 2.0f;
            ab1Active = false;
        }

        //Begins the coroutine that handles timing the search
        StartCoroutine(StartCountdown(timeToSearch, r));
    }

    /// <summary>
    /// Searches any room given with the detective who calls the function.
    /// </summary>
    /// <param name="r">A Reference to the room that we are attempting to search</param>
    override public void Interrogate(WitnessScript w)
    {

        if (w.interrogated)
        {
            return;
        }

        float timeToInterrogate = 180.0f;
        float similarityScale1 = (DetectiveStats.Det.Stats.WeakStrongScale - w.personality.WeakStrongScale) / 2.0f;
        float similarityScale2 = (DetectiveStats.Det.Stats.DepravedHonorableScale - w.personality.DepravedHonorableScale) / 2.0f;
        float similarityScale3 = (DetectiveStats.Det.Stats.LazyAmbitiousScale - w.personality.LazyAmbitiousScale) / 2.0f;

        float sim = (similarityScale1 + similarityScale2 + similarityScale3) / 3.0f;

        timeToInterrogate *= (sim / 100.0f);

        if (ab2Active)
        {
            timeToInterrogate = timeToInterrogate / 2.0f;
            ab2Active = false;
        }

        //Begins the coroutine that handles timing the search
        StartCoroutine(StartCountdown(timeToInterrogate, w, sim));
    }
}
